//+------------------------------------------------------------------+
//|                                               FX5_OmarSherif.mq4 |
//|                                            FX5, Copyright  2007 |
//|                                                    hazem@uk2.net |
//+------------------------------------------------------------------+
#property copyright "FX5, Copyright  2007"
#property link      "hazem@uk2.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Red
//---- input parameters

extern bool   enableAlert = true;
//---- buffers
double buySignal[];
double sellSignal[];

static datetime lastAlertTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);

   SetIndexBuffer(0, buySignal);
   SetIndexBuffer(1, sellSignal);

   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int LastAction = 0;

   for (int i = Bars - IndicatorCounted(); i >= 0; i--)
   {
      double ali1 = iRSI(NULL, 0, 14, PRICE_CLOSE, i+1);
      double ali2 = iMA(NULL, 0, 15, 0, MODE_SMA, PRICE_CLOSE,i+1);
      double ali3 = iMA(NULL, 0, 5, 0, MODE_SMA, PRICE_CLOSE,i+1);
      double al22 = iMA(NULL, 0, 15, 0, MODE_SMA, PRICE_CLOSE,i+2);
      double al23 = iMA(NULL, 0, 5, 0, MODE_SMA, PRICE_CLOSE,i+2);
      
      double displacement = GetArrowDisplacement(i);
   
      if (ali1>50&&al22>al23&&ali2<ali3)
      {
         if(LastAction != 1)
         {
            buySignal[i+1] = Low[i+1] - displacement;
            if (enableAlert == true && i == 0)
               SignalAlert("Buy signal On: ");
            LastAction = 1;
         }
      }
      
      if (ali1<50&&al22<al23&&ali2>ali3)
      {
         if(LastAction != 2)
         {
            sellSignal[i+1] = High[i+1] + displacement;
            if (enableAlert == true && i == 0)
               SignalAlert("Sell signal On: ");
            LastAction = 2;
         }
      }      
   }
   return(0);
}
//+------------------------------------------------------------------+
void SignalAlert(string message)
{
   if (Time[0] != lastAlertTime)
   {
      Alert(message, Symbol(), ", ", Period(), " Minutes chart");
      lastAlertTime = Time[0];
   }
}
//+------------------------------------------------------------------+
double GetArrowDisplacement(int i)
{
   double high = iMA(NULL, 0, 10, 0, MODE_SMA, PRICE_HIGH, i);
   double low = iMA(NULL, 0, 10, 0, MODE_SMA, PRICE_LOW, i);
   
   return ((high - low) / 2);
}
//+------------------------------------------------------------------+